#ifndef PEIMAGEHLP_H
#define PEIMAGEHLP_H

#define	PEIMAGE_ERROR_CODE(x)			((0x3<<28) | x)

#define	ERROR_EXCEPTION_OCCURED			PEIMAGE_ERROR_CODE(1)
#define	ERROR_RVA_NOT_IN_RAW_IMAGE		PEIMAGE_ERROR_CODE(8)
#define	ERROR_RVA_NOT_IN_IMAGE			PEIMAGE_ERROR_CODE(9)
#define ERROR_RAW_OFFSET_NOT_IN_IMAGE	PEIMAGE_ERROR_CODE(10)
#define ERROR_RAW_OFFSET_NOT_MAPPED		PEIMAGE_ERROR_CODE(11)
#define	ERROR_INVALID_DOS_FILE			PEIMAGE_ERROR_CODE(16)
#define	ERROR_INVALID_PE_FILE			PEIMAGE_ERROR_CODE(17)


PIMAGE_SECTION_HEADER WINAPI PeImageRvaToSection(PIMAGE_NT_HEADERS NtHeaders, PVOID Base, ULONG Rva, BOOL MemDisplacements);
PIMAGE_SECTION_HEADER WINAPI PeImageRawOffsetToSection(PIMAGE_NT_HEADERS NtHeaders, ULONG RawOffset);
PIMAGE_SECTION_HEADER WINAPI PeImageGetLastSection(PIMAGE_NT_HEADERS NtHeaders);
DWORD WINAPI PeImageRVAtoRawOffset(PIMAGE_NT_HEADERS NtHeaders, PVOID Base, ULONG Rva);
DWORD WINAPI PeImageRawOffsetToRVA(PIMAGE_NT_HEADERS NtHeaders, PVOID Base, ULONG RawOffset, BOOL MemDisplacements);
PIMAGE_NT_HEADERS WINAPI PeImageNtHeader(PVOID ImageBase);
PVOID WINAPI PeImageDirectoryEntryToDataEx(PVOID Base, BOOLEAN MappedAsImage, USHORT DirectoryEntry, PULONG Size, PIMAGE_SECTION_HEADER* FoundHeader);
DWORD WINAPI PeImageGetNewSectionInformation(PIMAGE_NT_HEADERS NtHeaders, PIMAGE_SECTION_HEADER pNewSectionInfo);
#endif
